//
//  CameraViewController.m
//  douBan
//
//  Created by ibokan on 13-4-17.
//  Copyright (c) 2013年 ibokan. All rights reserved.
//

#import "CameraViewController.h"
#import "ZBarSDK.h"
#import "ContentViewController.h"
#import "LayerVIew.h"
#import  <QuartzCore/QuartzCore.h>
@interface CameraViewController ()
{
    ZBarReaderViewController *reader;
    
}
@end

@implementation CameraViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
        self.title=@"扫描";
         self.navigationItem.rightBarButtonItem=[[[UIBarButtonItem alloc] initWithTitle:@"书库" style:UIBarButtonSystemItemUndo target:self action:@selector(gobackToLocalBook)] autorelease];
        self.view.backgroundColor=[UIColor blackColor];
    }
    return self;
}

-(void)dealloc
{
    [beep release];
    
    [super dealloc];
}
- (void)viewDidLoad
{
    [super viewDidLoad];
    
    UIButton *button=[UIButton buttonWithType:UIButtonTypeCustom];
    button.frame=CGRectMake(90, 140, 140, 70);
    [button addTarget:self action:@selector(camareGo) forControlEvents:UIControlEventTouchUpInside];
    [button setTitle:@"扫描" forState:UIControlStateNormal];
    button.backgroundColor=[UIColor brownColor];
    [self.view addSubview:button];
    [self initAudio];
    
	// Do any additional setup after loading the view.
}
-(void)camareGo
{
    /*扫描二维码部分：
     导入ZBarSDK文件并引入一下框架
     AVFoundation.framework
     CoreMedia.framework
     CoreVideo.framework
     QuartzCore.framework
     libiconv.dylib
     引入头文件#import “ZBarSDK.h” 即可使用
     
     当找到条形码时，会执行代理方法
     - (void) imagePickerController: (UIImagePickerController*) reader didFinishPickingMediaWithInfo: (NSDictionary*) info
     
     最后读取并显示了条形码的图片和内容。*/
    if (reader) {
        [reader release];
    }
    
    
    ibsnIsAvielbel=YES;
    reader=[ZBarReaderViewController new];
    reader.readerDelegate=self;
    [reader setShowsZBarControls:YES];
   
    //
    LayerVIew *layerView=[[LayerVIew alloc] initWithFrame:CGRectMake(0.0, 0.0, 320.0, 440)];
    layerView.backgroundColor=[UIColor clearColor];
    [reader setCameraOverlayView:layerView];
    
    [layerView release];
    
    
    
	reader.readerView.torchMode = 0;
    //
    ZBarImageScanner *scanner=reader.scanner;
    
    [scanner setSymbology: ZBAR_ISBN10
  				   config: ZBAR_CFG_ENABLE
  					   to: 1];
    [scanner setSymbology: ZBAR_ISBN13
                   config: ZBAR_CFG_ENABLE
                       to: 1];
    //
    //[scanner setSymbology:ZBAR_I25 config:ZBAR_CFG_ENABLE to:0];
    
    
    [self presentViewController:reader animated:YES completion:^{
        
    }];
    
    
    
}
//声音播放
- (void)initAudio
{
    if(beep)
        return;
    NSError *error = nil;
//    beep = [[AVAudioPlayer alloc]
//			initWithContentsOfURL:
//			[[NSBundle mainBundle]
//			 URLForResource: @"scan"
//			 withExtension: @"wav"]
//			error: &error];
    
    
    beep=[[AVAudioPlayer alloc] initWithContentsOfURL:[[NSBundle mainBundle] URLForResource:@"scan" withExtension:@"wav"] error:&error];
    
    if(!beep)
        NSLog(@"ERROR loading sound: %@: %@",
              [error localizedDescription],
              [error localizedFailureReason]);
    else {
        beep.volume = .5f;
        [beep prepareToPlay];
    }
}
- (void) playBeep
{
    if(!beep)
        [self initAudio];
    [beep play];
}
- (void)imagePickerController: (UIImagePickerController*) reader1
didFinishPickingMediaWithInfo: (NSDictionary*) info

{
   
//    if (!ibsnIsAvielbel) {
//        return;
//    }
//    ibsnIsAvielbel=NO;
    id<NSFastEnumeration> results =
    [info objectForKey: ZBarReaderControllerResults];
    
    ZBarSymbol *symbol = nil;
    for(symbol in results)
        
        break;
    
    

    //如果没值返回
    if (!symbol.data) {
        UIAlertView *alertV=[[UIAlertView alloc] initWithTitle:@"message" message:@"zBarFailed" delegate:self cancelButtonTitle:@"确定" otherButtonTitles: nil];
        [alertV show] ;
        [alertV release];
        return;
    }
    //如果格式不对返回
    if (symbol.type!=ZBAR_ISBN13&&symbol.type!=ZBAR_ISBN10) {
       
        ibsnIsAvielbel=YES;
        
        UIAlertView *alertV=[[UIAlertView alloc] initWithTitle:@"message" message:@"我擦 你扫的什么" delegate:self cancelButtonTitle:@"确定" otherButtonTitles: nil];
        [alertV show] ;
        [alertV release];
        NSLog(@"尼玛"); 
        
        return;
    }
    
    //执行完毕播放声音
    [self playBeep];
   
    //根据ibsn进行网络请求
    
   [self getRequeset:symbol.data];
     NSLog(@"dsfssffdsfsdfsdfsdfsdfsdfsdfsf%@",symbol.data);
    [reader1 dismissViewControllerAnimated:YES completion:^{
        [reader release];
        reader=nil;
    }];
    //[info objectForKey: UIImagePickerControllerOriginalImage];
    
    
}
-(void)getRequeset:(NSString*)searchText;
{
    
    NSLog(@"条形码ibsn%@",searchText);
    
    //7010020698
   NSURL *url=[NSURL URLWithString:[NSString stringWithFormat:@"https://api.douban.com/v2/book/isbn/%@&apikey=%@",searchText,KappKey]];
   
    
    
    //NSURL *url=[NSURL URLWithString:[NSString stringWithFormat:@"https://api.douban.com/v2/book/isbn/%@&apikey=0b8a3dccc806ff74229eb9665814fe5c",searchText]];
    //  NSURL *url=[NSURL URLWithString:[NSString stringWithFormat:@"https://api.douban.com/v2/book/isbn/7505715666&apikey=%@",KappKey]];
    
    NSURLRequest *request=[NSURLRequest requestWithURL:url];
    
    [NSURLConnection sendAsynchronousRequest:request queue:[NSOperationQueue mainQueue] completionHandler:^(NSURLResponse *re, NSData *data, NSError *err) {
        
        if (err) {
            return ;
            NSLog(@"dsgsg");
        }
        
        [self getdata:data];
    }];
}
-(void)getdata:(NSData *)data
{
    NSString *str=[[[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding] autorelease];
    NSDictionary*booksDictiory=[str JSONValue];
  //  NSLog(@"%d",[booksDictiory count]);
    NSLog(@"%@",booksDictiory );
    
    
    Book *searchbook=[[[Book alloc] init] autorelease];
    searchbook.authorName=[[booksDictiory objectForKey:@"author"] lastObject];
    searchbook.bookId=[booksDictiory objectForKey:@"url"];
    searchbook.imageStr=[booksDictiory objectForKey:@"image"];
    searchbook.pages=[booksDictiory objectForKey:@"pages"];
    searchbook.title=[booksDictiory objectForKey:@"title"];
    searchbook.price=[booksDictiory objectForKey:@"price"];
    searchbook.author_intro=[booksDictiory objectForKey:@"author_intro"];
    searchbook.translator=[booksDictiory objectForKey:@"translator"];
    searchbook.summary=[booksDictiory objectForKey:@"summary"];
    
    
    ContentViewController *content = [[ContentViewController alloc]init];
    
    content.book=searchbook;
   
    content.title=content.book.title;
    [self.navigationController pushViewController:content animated:YES];
    [content release];
    
    
}
-(void)gobackToLocalBook
{
    NSLog(@"哈哈哈");
    CATransition *animation=[CATransition animation];
   
    animation.delegate=self;
    animation.duration=0.4f;
    //过渡快慢
    animation.timingFunction=UIViewAnimationCurveEaseInOut;
    //动画模式
    animation.type=kCATransitionReveal;
    //动画方向
    animation.subtype=kCATransitionFromLeft;
    [self.navigationController.tabBarController.view.window.layer addAnimation:animation forKey:@"move in"];
}
-(void)animationDidStart:(CAAnimation *)anim
{
    [self.navigationController.tabBarController dismissViewControllerAnimated:NO completion:^{
        
    }];
}
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
