//
//  Book.m
//  DBReader
//
//  Created by Ibokan on 13-4-16.
//  Copyright (c) 2013年 刘浩. All rights reserved.
//

#import "Book.h"

@implementation Book

-(void)dealloc
{
    [_title release];
    [_author_intro release];
    [_authorName release];
    [_bookId release];
    [_imageStr release];
    [_image release];
    [_price release];
    [_pages release];
    [_summary release];
    [_translator release];
    [_tags release];
    [_publisher release];
    [_bookPinLun release];
    [super dealloc];
    
}
//将ReadBook转换成book
+(Book *)bookWithReadBook:(ReadBook *)readbook;
{
    Book *book=[[Book alloc] init];
        book.image=[UIImage imageWithData:readbook.image];
        book.bookId=readbook.bookId;
        book.summary=readbook.summary;
        book.authorName=readbook.authorName;
        book.title=readbook.title;
        book.imageStr=readbook.imageStr;
        book.pinglunCout=[readbook.pinglunCount integerValue];
        book.bookId=readbook.bookId;
   
    
    
    return [book autorelease];
}
//创建一个 ReadBook 然后赋值
-(ReadBook *)createReadBookWithBook:(Book *)book;
{
    ReadBook *readB =[[BookManager defaultBookManager]  readbook];
    readB.title=book.title;
    readB.image=UIImagePNGRepresentation(book.image);
    readB.summary=book.summary;
    readB.bookId=book.bookId;
    readB.authorName=book.authorName;
    readB.pinglunCount=[NSString stringWithFormat:@"%d",book.pinglunCout];
    readB.bookId=book.bookId;
    return readB;

}
@end
