//
//  BookCell.m
//  DBReader
//
//  Created by Ibokan on 13-4-16.
//  Copyright (c) 2013年 刘浩. All rights reserved.
//

#import "BookCell.h"

@implementation BookCell

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        // Initialization code
//        UITableView *table= (UITableView *)self.superview;
//        self.frame=CGRectMake(0, 0, 320, table.rowHeight);
        _bookImageView=[[UIImageView alloc] initWithFrame:CGRectMake(0, 0, 60, 70)];
        _titleLable=[[UILabel alloc] initWithFrame:CGRectMake(60, 4, 240, 26)];
        _authurLabel=[[UILabel alloc] initWithFrame:CGRectMake(60, 30, 240, 40)];
        _authurLabel.font=[UIFont systemFontOfSize:12];
        _authurLabel.numberOfLines=3;
        [self addSubview:_bookImageView];
        [self addSubview:_titleLable];
        [self addSubview:_authurLabel];
    }
    return self;
}
-(void)setBook:(Book *)book
{
    if ([_book isEqual:book]) {
        return;
    }
    _book=[book retain];
    self.titleLable.text=_book.title;
    self.authurLabel.text=_book.authorName;
    [self.bookImageView setImageWithURL:[NSURL URLWithString:_book.imageStr] placeholderImage:[UIImage imageNamed:@"11.jpg"] completed:^(UIImage *image, NSError *error, SDImageCacheType cacheType) {
        book.image=image;
    }];
   
}
-(void)dealloc
{
    [_book release];
    [_bookImageView release];
    [_titleLable release];
    [_authurLabel release];
    [super dealloc];
}
- (void)setSelected:(BOOL)selected animated:(BOOL)animated
{
    [super setSelected:selected animated:animated];

    // Configure the view for the selected state
}

@end
