//
//  ContentViewController.m
//  douBan
//
//  Created by Ibokan on 13-4-18.
//  Copyright (c) 2013年 ibokan. All rights reserved.
//
#define Collect     @"收藏"
#define UnCollect     @"删除"
#import "ContentViewController.h"
#import "RewiewCell.h"
#import "ReadingViewController.h"
//书朋网api
#define KshuPengWangAppKey    @"04b38c129d41730505d8d6f103e3c6bb"

@interface ContentViewController ()
{
    
       
    

    float rowHeight;
    UIActivityIndicatorView * _activityIndicator;
}

@property(nonatomic,retain)NSMutableArray *pingLunArray;
@property(nonatomic,retain)ReaderPinLun *ping;

@property(nonatomic,retain)UITableView *tableView;
@property(nonatomic,retain)NSMutableArray * indexPathRow;


-(void)loadAutherImageForRewiew:(ReaderPinLun *) rewiew;


@end

@implementation ContentViewController
-(float)returnRowHigetText:(NSString *)contentText :(NSInteger)whidth;
{
    UILabel *label=[[[UILabel alloc] initWithFrame:CGRectMake(0, 0, (float)whidth, 0)] autorelease];
    label.numberOfLines=0;
   
    label.text=[NSString stringWithFormat:@"%@",contentText];
    label.font=[UIFont fontWithName:@"Arial" size:14];
    [label sizeToFit];
    if ([contentText isEqualToString:@""]||contentText==nil) {
        return 50;
    }
    return label.frame.size.height*1.03;
}

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil

{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
        _moRenHeight=20;
        self.indexPathRow =[NSMutableArray array];
        
        self.pingLunArray=[NSMutableArray array];
       
        self.navigationItem.rightBarButtonItem=[[[UIBarButtonItem alloc] initWithTitle:@"书库" style:UIBarButtonItemStyleDone target:self    action:@selector(goBackToLocal)] autorelease];
       
    }
    return self;
}
-(void)dealloc
{
    [_delegate release];
    [_activityIndicator release];
    [_pingLunArray release];
    [_book release];
    [super dealloc];
}
-(void)goBackToLocal
{
  
   
    
    [UIView beginAnimations:@"image" context:NULL];
    [UIView setAnimationDuration:0.4];
    [UIView setAnimationCurve:UIViewAnimationCurveEaseIn];
    UIWindow *window=self.navigationController.tabBarController.view.window;
    
    [UIView setAnimationTransition:UIViewAnimationTransitionFlipFromLeft forView:window cache:NO];
    
    [UIView commitAnimations];
    [self.navigationController.tabBarController  dismissViewControllerAnimated:NO completion:^{
        
    }];
}
- (void)viewDidLoad
{
    [super viewDidLoad];
    //
    _activityIndicator=[[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhiteLarge];
    _activityIndicator.color=[UIColor blackColor];
    _activityIndicator.frame=CGRectMake(30, 9, 80, 80);
    _activityIndicator.center=self.view.center;
    //加载tableHeaderView
    self.view.backgroundColor=[UIColor whiteColor];
    UITableView *tableV=[[UITableView alloc] initWithFrame:CGRectMake(5, 20, 310, 415) style:UITableViewStylePlain];
    [tableV setContentMode:UIViewContentModeRedraw];
    
    
    tableV.delegate=self;
    tableV.dataSource=self;
    //tableV.showsVerticalScrollIndicator=NO;
    
    [tableV setSeparatorStyle:UITableViewCellSeparatorStyleSingleLine];
   
   tableV.separatorColor= [UIColor colorWithRed:229.0/255.0 green:250.0/255.0 blue:230.0/255.0 alpha:1];

  
    [self.view addSubview: tableV];
   
    self.tableView=tableV;
    
    
    NSLog(@"2222222");
    [tableV release];
    [self tableViewHeaderView];
    ReadBook *readBook=[[[BookManager defaultBookManager] bookMutableArryTitle:self.book.bookId] lastObject];
    if (_loading) {
        [self.readButton setTitle:@"loading" forState:UIControlStateNormal];
        self.readButton.enabled=NO;
    }
    if ([readBook.reload isEqual:@(YES)]) {
        [self.readButton setTitle:@"阅读" forState:UIControlStateNormal];
        self.readButton.enabled=YES;

    }
    
    
    //判断是否有下载
    
    [self.view addSubview:_activityIndicator];

    
   
    self.book.bookId=[self.book.bookId stringByReplacingOccurrencesOfString:@"http://api.douban.com/v2/book/" withString:@""];

    //获取评论
    [self posturl];

    
}
-(void)posturl
{
    NSURL *url=[NSURL URLWithString:[NSString stringWithFormat:@"http://api.douban.com/book/subject/%@/reviews?alt=json&apikey=07be21a01a1c35f1173a64e04e54a1d3",self.book.bookId]];
    NSURLRequest *request=[NSURLRequest requestWithURL:url];
    [NSURLConnection sendAsynchronousRequest:request queue:[NSOperationQueue mainQueue] completionHandler:^(NSURLResponse *response, NSData *data, NSError *error) {
        if (error) {
            return ;
        }
        [self jsonData:data];
    }];
}

-(void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    NSLog(@"33333333");
   
    //检索数据库看是否保存过
    self.tableView.frame=CGRectMake(5, self.moRenHeight, 310, 415);
    

    
      
    NSMutableArray *array1=[[BookManager defaultBookManager] bookMutableArryTitle:self.book.bookId];
    ReadBook *read=[array1 lastObject];
           if ([read.bookId isEqualToString: self.book.bookId ]) {
            [self.collectButton setTitle:UnCollect forState:UIControlStateNormal];

          }
    
    [self.tableView reloadData];
   
}
-(void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
    [UIView animateWithDuration:0.5 animations:^{
        if (self.tabBarController) {
            
            self.tabBarController.view.frame=CGRectMake(0, 0, 320, 528);
        }
        
        
    }];

}
-(void)viewWillDisappear:(BOOL)animated
{
    [super viewWillDisappear:animated];
   
            
            self.tabBarController.view.frame=CGRectMake(0, 0, 320, 480);
   


    
           
    
}
//设置tableViewHeaderView
-(void)tableViewHeaderView
{
    //header view
    UIView *headerView = [[UIView alloc] initWithFrame:CGRectMake(0.0, 10.0, 320, 170)];
    UIImageView *bookImage = [[UIImageView alloc] initWithFrame:CGRectMake(0.0, 10.0, 120, 150)];
    
    if (self.book.image) {
     
        bookImage.image =self.book.image;
        
    }else{
             [bookImage setImageWithURL:[NSURL URLWithString:self.book.imageStr]  placeholderImage:[UIImage imageNamed:@"11.jpg"] completed:^(UIImage *image, NSError *error, SDImageCacheType cacheType) {
            self.book.image=image;
        }];
    }
    
    UILabel *bookNameLabel = [[UILabel alloc] initWithFrame:CGRectMake(135.0, 0.0, 180.0, 80.0)];

    bookNameLabel.numberOfLines=0;
    UILabel *publishersLabel = [[UILabel alloc] initWithFrame:CGRectMake(135.0, 80, 180.0, 40.0)];
   self.collectButton=[UIButton buttonWithType:UIButtonTypeCustom];
    self.collectButton.frame=CGRectMake(135.0, 127.0, 75, 40);
    [self.collectButton addTarget:self action:@selector(collectBook) forControlEvents:UIControlEventTouchUpInside];
    [self.collectButton setTitle:Collect forState:UIControlStateNormal];
    self.collectButton.backgroundColor=[UIColor brownColor];
    
   
    UIButton *readButton=[UIButton buttonWithType:UIButtonTypeCustom];
    [readButton setBackgroundColor:[UIColor brownColor]];
    [readButton addTarget:self action:@selector(reloadreadBook:) forControlEvents:UIControlEventTouchUpInside];
    [readButton setTitle:@"下载" forState:UIControlStateNormal];
    
    readButton.frame=CGRectMake(220, 127, 80, 40);
    
    
    bookNameLabel.font = [UIFont fontWithName:@"Baskerville-Italic" size:19.0];
 
    publishersLabel.font = [UIFont fontWithName:@"Baskerville-Italic" size:14.0];
  
    
    
    bookNameLabel.text = self.book.title;
  
    

    
    if (!self.book.publisher) {
        
        publishersLabel.text = @"未知";
        
        
    }else{
        
        publishersLabel.text = [NSString stringWithFormat:@"出版社%@",self.book.publisher];
        
        
    }
     
    [headerView addSubview:publishersLabel];
    [headerView addSubview:bookNameLabel];
   // [headerView addSubview:authorLabel];
    [headerView addSubview:bookImage];
    [headerView addSubview:readButton];
    [headerView addSubview:self.collectButton];
    self.readButton=readButton;
    self.tableView.tableHeaderView = headerView;
   
   
    [bookNameLabel release];
    [publishersLabel release];
    //[authorLabel release];
   
    [bookImage release];
    [headerView release];

}
-(void)reloadreadBook:(id)sender
{
    UIButton *button   =(UIButton *)sender;
    if ([button.titleLabel.text isEqualToString:@"下载"]) {
        
        if ( [self.collectButton.titleLabel.text isEqualToString:Collect]) {
            
            [self.book createReadBookWithBook:self.book];
            [self.collectButton setTitle:UnCollect forState:UIControlStateNormal];
        }
                
        if ([self.delegate respondsToSelector:@selector(reloadBook:)])
        {
            self.delegate.book=self.book;
            [self.delegate reloadBook:self.book.title];
            
            [self.readButton setTitle:@"loading" forState:UIControlStateNormal];
            self.readButton.enabled=NO;
        }

    }
    else{
        //书本的路径
        NSString *filePath=[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) lastObject];
        NSString *flieP=[filePath stringByAppendingFormat:@"%@.tex",self.book.bookId];
        
        ReadingViewController *readView=[[ReadingViewController alloc] init];
        readView.filePath=flieP;
        [self.navigationController pushViewController:readView animated:YES];
        [readView release];

    }
    
   
}


-(void)jsonData:(NSData *)data
{
    //json解析数据
    NSString *jsonStr=[[[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding] autorelease];
    NSDictionary *dic=[jsonStr JSONValue];
   // NSLog(@"%@",dic);
    
    //评论数
    self.book.pinglunCout=[[[dic objectForKey:@"opensearch:totalResults"] objectForKey:@"$t"] intValue];
    
    [self.pingLunArray removeAllObjects];
    
    if (self.book.pinglunCout==0) {
        return;
    }
 
    //
    NSArray *array=[dic objectForKey:@"entry"];
    for (NSDictionary * detailDictionary in array) {
        
        //创建实例接收评论属性
        ReaderPinLun *ping=[[ReaderPinLun alloc] init];
        
        ping.author=[[[detailDictionary objectForKey:@"author"] objectForKey:@"name"] objectForKey:@"$t"];
        //作者地址
        for (NSDictionary *lind in [[detailDictionary objectForKey:@"author"] objectForKey:@"link"]) {
            
            if ([[lind objectForKey:@"@rel"] isEqualToString:@"alternate"])
            {
                ping.authorlink=[lind objectForKey:@"@href"];
            }
        }
        
        //作者头像连接
        for (NSDictionary *lind in [[detailDictionary objectForKey:@"author"] objectForKey:@"link"]) {
            
            if ([[lind objectForKey:@"@rel"] isEqualToString:@"icon"])
            {
                ping.authorImageStr=[lind objectForKey:@"@href"];
            }
        }
        
        //获取作者头像
      
        
        //评论完整地址
        for (NSDictionary *lind in [detailDictionary objectForKey:@"link"]) {
            if ([[lind objectForKey:@"@rel"] isEqualToString:@"alternate"])
            {
                ping.summarylink=[lind objectForKey:@"@href"];
                
            }
        }
        
        //出版时间
        ping.publishedTime=[[detailDictionary objectForKey:@"published"] objectForKey:@"$t"];
       
        //评论概要
        ping.summary=[[detailDictionary objectForKey:@"summary"] objectForKey:@"$t"];
       
        //评论的标题
        ping.title=[[detailDictionary objectForKey:@"title"] objectForKey:@"$t"];
        
        self.ping = ping;
        [self.pingLunArray addObject:ping];
        NSLog(@"%@",ping.summarylink);
       // NSLog(@"%@",ping);
        [ping release];
        
        
        
    }

    [self.tableView reloadData];
    
    

}

//下载rewiewer的图片
-(void)loadAutherImageForRewiew:(ReaderPinLun *) rewiew
{
    NSString *urlString = rewiew.authorImageStr;
    rewiew.authorImage = [UIImage imageWithData:[NSData dataWithContentsOfURL:[NSURL URLWithString:urlString]]];
    
}


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    
    // Return the number of sections.
    return 3;
}
-(CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (indexPath.section==0) {
       
        return [self returnRowHigetText:self.book.author_intro :310]*1.13 +30;
    }
    else
        if (indexPath.section==1) {

            
            return [self returnRowHigetText:self.book.summary :310]*1.13 +10;

         
        }
        else
        {
            
            
            for (NSIndexPath *indexP in self.indexPathRow) {
                if (indexP.row==indexPath.row)
                {
                    ReaderPinLun *reader=[self.pingLunArray objectAtIndex:indexPath.row];
                    
                    return [ self returnRowHigetText:reader.summary :275.0]/1.03+140
                    ;
                }
            }
          
            return 190;
        }
    
}
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    
    // Return the number of rows in the section.
   // NSLog(@"ddddddddddd%d",[self.pingLunArray count]);
    if (section==0) {
        
        return 1;
        
    }else if (section==1) {
            
            return 1;
            
        }
        else
        {
            
            NSLog(@"%d",[self.pingLunArray count]);
            return [self.pingLunArray count];
            
        }
    
}
-(NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section
{
    if (section==0) {
        
        return @"作者简介";
        
    }
    else if (section==1) {
        
            return @"书本概要";
        
        }
        else
        {
            
            return [NSString stringWithFormat:@"评论(%d)",self.book.pinglunCout];
            
        }
    
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (indexPath.section==0) {
        
        static NSString *CellIdentifier = @"Cellsf";
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
        if (!cell ) {
            cell=[[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
            
        }
        

        cell.textLabel.font=[UIFont fontWithName:@"Arial" size:14];
         cell.textLabel.numberOfLines=0;
         if ([self.book.author_intro isEqualToString:@""]||self.book.author_intro==nil)
         {
             self.book.author_intro=@"暂无简介";
             
         }
        cell.textLabel.text=[NSString stringWithFormat:@"%@\n%@",self.book.authorName,self.book.author_intro];
    //鲁迅
        return cell;
        
    }
    if (indexPath.section==1)
    {
        
        static NSString *CellIdentifier = @"Cell13sdf";
        UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
        if (!cell ) {
            cell=[[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
            
        }
        cell.textLabel.font=[UIFont fontWithName:@"Arial" size:14];
//        cell.detailTextLabel.font = [UIFont fontWithName:@"Arial" size:12.0];
       
        cell.textLabel.numberOfLines=0;
        
        if ([self.book.summary isEqualToString:@""]||self.book.summary==nil)
        {
            cell.textLabel.text=@"暂无简介";
            return cell;
        }

       cell.textLabel.text=[NSString stringWithFormat:@"%@",self.book.summary];
        
        return  cell;
        
        
    }else{
    
    
        static NSString *CellIdentifier = @"Cell222sdf";
        RewiewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
        
        if (!cell ) {
            
            cell=[[[RewiewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
            
        }
        cell.contentViewController=self;
        //获取作者头像
       
        ReaderPinLun *pinLun=[self.pingLunArray objectAtIndex:indexPath.row];
        
       
        //如果获取了详细信息
        for (NSIndexPath *indexP in self.indexPathRow)
        {
            if (indexP.row==indexPath.row)
            {
                cell.rewiewContentLabel.text=pinLun.summary;
                cell.rewiewerNameLabel.text =pinLun.author;
                cell.dateLabel.text = pinLun.publishedTime;
                
                 cell.rewiewContentLabel.font=[UIFont fontWithName:@"Arial" size:14];
                cell.rewiewContentLabel.numberOfLines=0;
                
                
                [cell.rewiewContentLabel sizeToFit];
                
                cell.moreButton.frame=CGRectMake(220.0, cell.rewiewContentLabel.frame.size.height*1.005+59, 90, 55);
                
                [cell.moreButton setTitle:@"收起<<" forState:UIControlStateNormal];
              
                cell.dateLabel.frame=CGRectMake(15.0, cell.rewiewContentLabel.frame.size.height*1.005+89, 231.0, 30.0);
                [cell.moreButton setTitleColor:[UIColor brownColor] forState:UIControlStateNormal];
                cell.moreButton.titleLabel.font=[UIFont systemFontOfSize:15.0];
                
                if (pinLun.authorImage) {
                    cell.rewiewerImage.image=pinLun.authorImage;
                }
                else{
                [cell.rewiewerImage setImageWithURL:[NSURL URLWithString:pinLun.authorImageStr] placeholderImage:[UIImage imageNamed:@"user_placeholder.jpg.jpg"] completed:^(UIImage *image, NSError *error, SDImageCacheType cacheType) {
                    pinLun.authorImage=image;
                    
                }];
                }

                return cell;
            }
        }
        
         
       
        cell.rewiewContentLabel.frame=CGRectMake(18.0, 65.0, 275.0, 80.0);
        cell.rewiewContentLabel.font=[UIFont fontWithName:@"Arial" size:14];
        cell.rewiewContentLabel.numberOfLines=3;
        
        
        [cell.moreButton setTitle: @"详细>>" forState:UIControlStateNormal];
        [cell.moreButton setTitleColor:[UIColor brownColor] forState:UIControlStateNormal];
        cell.moreButton.titleLabel.font=[UIFont systemFontOfSize:15.0];

        cell.rewiew = pinLun;
        return  cell;

        }
    
    
}


//设置section的头
- (UIView *)tableView:(UITableView *)tableView viewForHeaderInSection:(NSInteger)section
{
    
    NSString *sectionTitle = [self tableView:tableView titleForHeaderInSection:section];
    if (sectionTitle == nil) {
        return  nil;
    }
    
    UILabel * label = [[[UILabel alloc] init] autorelease];
    label.frame = CGRectMake(0, 0, 310, 22);
    label.backgroundColor = [UIColor clearColor];
    //label.backgroundColor = [UIColor colorWithRed:204.0/255.0 green:255.0/255.0 blue:230.0/255.0 alpha:1];
    label.backgroundColor = [UIColor colorWithRed:229.0/255.0 green:250.0/255.0 blue:230.0/255.0 alpha:1];
      
    //label.backgroundColor = [UIColor brownColor];
    label.font=[UIFont fontWithName:@"Arial" size:14];
    label.text = sectionTitle;
    
    UIView * sectionView = [[[UIView alloc] initWithFrame:CGRectMake(0, 0, tableView.bounds.size.width, 220)] autorelease];
    [sectionView setBackgroundColor:[UIColor whiteColor]];
    [sectionView addSubview:label];
    return sectionView;
    
}


#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    [tableView deselectRowAtIndexPath:indexPath animated:YES];
   
    
}


#pragma mark -collect
-(void)collectBook
{
    NSString *titleStr=nil;
    if ([self.collectButton.titleLabel.text isEqualToString:Collect]) {

        //将book转换成readBook永久保存
        [self.book createReadBookWithBook:self.book];

        //保存评论
        [self.collectButton setTitle:UnCollect forState:UIControlStateNormal];
        titleStr=Collect;
    }
    else{
        self.delegate.progressView.alpha=0;
        [self.delegate.connection cancel];
        self.delegate.isloading=NO;
        
        
        
        [self.collectButton setTitle:Collect forState:UIControlStateNormal];
        [self.readButton setTitle:@"下载" forState:UIControlStateNormal];
        NSMutableArray *array1=[[BookManager defaultBookManager] bookMutableArryTitle:self.book.bookId];
        ReadBook *read=[array1 lastObject];      
            if ([read.bookId isEqualToString: self.book.bookId ])
                [[BookManager defaultBookManager]  deleteObject:read];
     //删除下载的内容
        //书本的路径
        NSString *filePath=[NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES) lastObject];
        NSString *flieP=[filePath stringByAppendingFormat:@"%@.tex",self.book.bookId];
        if ([[NSFileManager defaultManager] fileExistsAtPath:flieP]) {
            [[NSFileManager defaultManager] removeItemAtPath:flieP error:nil];
        }
         titleStr=UnCollect;
    }
    
    
    UIAlertView *alertV=[[[UIAlertView alloc] initWithTitle:@"message" message:[NSString stringWithFormat:@"%@successed",titleStr] delegate:self cancelButtonTitle:@"确定" otherButtonTitles: nil] autorelease];
    [alertV show];
    
    
    
    
    
}
#pragma mark-获取丰富的评论
-(void)reloadCellAtIndexPath:(NSIndexPath * )indexPath WithUrl:(NSString *)urlStr;
{

    NSLog(@"%@",urlStr);
    [_activityIndicator startAnimating];
    urlStr=[urlStr stringByReplacingOccurrencesOfString:@"http://www.douban.com/review" withString:@""];
    NSLog(@"%@",urlStr);
//    NSLog(@"%@",urlStr);
//    
    NSURL *url = [NSURL URLWithString:[NSString stringWithFormat:@"http://book.douban.com/review%@",urlStr]];
//    NSURL *url = [NSURL URLWithString:[NSString stringWithFormat:@"http://book.douban.com/review/3428278/"]];
     
    NSURLRequest *request = [NSURLRequest requestWithURL:url];
    [NSURLConnection sendAsynchronousRequest:request queue:[NSOperationQueue mainQueue] completionHandler:^(NSURLResponse *response, NSData *data, NSError *error) {
        [self reloadWithData:data andIndextPath:indexPath];
    }];
   
}
-(void)reloadWithData:(NSData *)data andIndextPath:(NSIndexPath *)indexPath
{
    NSString *str=[[[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding] autorelease];
    NSMutableString *mutaleStr=[NSMutableString stringWithString:str];

    NSRange range1=[str rangeOfString:@"<span property=\"v:description\" class=\"\">"];
   
    NSRange range2=[str rangeOfString:@"<div class=\"clear\"></div>"];
 
   
    str=  [mutaleStr substringWithRange:NSMakeRange(range1.location+range1.length, range2.location-range1.location-range1.length)];
 
    mutaleStr=[NSMutableString stringWithString:str];
    range2=[str rangeOfString:@"</span>"];
    str=[mutaleStr substringWithRange:NSMakeRange(0, range2.location)];
    str=[str stringByReplacingOccurrencesOfString:@"<br/>" withString:@""];

    
    ReaderPinLun *read =[self.pingLunArray objectAtIndex:indexPath.row];

   read.summary = str ;
    
    [_activityIndicator stopAnimating];
    
    [self.indexPathRow addObject:indexPath];
    
    [self.tableView reloadRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationNone];
}
-(void)packUpCellAtIndexPath:(NSIndexPath *) indexPath;
{
    for (NSIndexPath *index in self.indexPathRow) {
        if (indexPath.row==index.row) {
            
            [self.indexPathRow removeObject:index];
            [self.tableView reloadRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationNone];
            return;
            
        }
    }
    



}
-(void)showAlertView:(NSString *)messageStr
{
    if ([messageStr isEqualToString:@"下载成功"]) {
        [self.readButton setTitle:@"阅读" forState:UIControlStateNormal];
    }
    else{
        [self.delegate.progressView removeFromSuperview];
        self.delegate.progressView.alpha=0;
        [self.readButton setTitle:@"下载" forState:UIControlStateNormal];

    }
    UIAlertView *alertView1=[[UIAlertView alloc] initWithTitle:@"message" message:messageStr delegate:self cancelButtonTitle:@"确定" otherButtonTitles: nil];
    [alertView1 show] ;
    [alertView1 release];
    self.readButton.enabled =YES;
}
@end
