//
//  AppDelegate.m
//  douBan
//
//  Created by ibokan on 13-4-15.
//  Copyright (c) 2013年 ibokan. All rights reserved.
//

#import "AppDelegate.h"
#import "DBViewController.h"
#import "AboutViewController.h"

#import "CameraViewController.h"
#import "LocalViewController.h"


@implementation AppDelegate

- (void)dealloc
{
    [_window release];
    [_viewController release];
    [super dealloc];
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    self.window = [[[UIWindow alloc] initWithFrame:[[UIScreen mainScreen] bounds]] autorelease];
    // Override point for customization after application launch.
    //heihe第三方说的发生地方随碟附送   
    LocalViewController *localViewCon=[[LocalViewController alloc]  init];
   UINavigationController *navigation0 = [[UINavigationController alloc]initWithRootViewController:localViewCon];
    navigation0.navigationBar.tintColor = [UIColor blackColor];
       
    
   
    DBViewController *douBan = [[DBViewController alloc]init];
    UINavigationController *navigation1 = [[UINavigationController alloc]initWithRootViewController:douBan];
    navigation1.navigationBar.tintColor = [UIColor blackColor];
    
  
    
    CameraViewController *camera = [[CameraViewController alloc]init];
    UINavigationController *navigation2 = [[UINavigationController alloc]initWithRootViewController:camera];
    navigation2.navigationBar.tintColor = [UIColor blackColor];
    navigation2.tabBarItem.title = @"Camera";
    navigation2.tabBarItem.image = [UIImage imageNamed:@"barcode.png"];
   
//    
//    RecordViewController *record = [[RecordViewController alloc]init];
//    UINavigationController *navigation3 = [[UINavigationController alloc]initWithRootViewController:record];
//    navigation3.navigationBar.tintColor = [UIColor blackColor];
//    navigation3.tabBarItem.title = @"Record";
//    navigation3.tabBarItem.image = [UIImage imageNamed:@"zerostar.png"];
    
    
    
    AboutViewController *about = [[AboutViewController alloc]init];
    UINavigationController *navigation4 = [[UINavigationController alloc]initWithRootViewController:about];
    navigation4.navigationBar.tintColor = [UIColor blackColor];
    navigation4.tabBarItem.title = @"About";
    navigation4.tabBarItem.image = [UIImage imageNamed:@"more"];
   
    
    UITabBarController *tabBar = [[UITabBarController alloc]init];
    tabBar.viewControllers = [NSArray arrayWithObjects:navigation1,navigation2,navigation4,nil];
    self.window.rootViewController = navigation0 ;
    localViewCon.delegate=douBan;
    localViewCon.TabBardelegate=tabBar;
    douBan.localViewCon=localViewCon;
    douBan.navigationlocalViewCon=navigation0;
    [self.window makeKeyAndVisible];

     [camera release];
//    [record release];
     [about release];
    [douBan release];
    [localViewCon release];
    
    
    [navigation1 release];
    [navigation2 release];
//    [navigation3 release];
    [navigation4 release];
    [navigation0 release];
    [tabBar release];
        return YES;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

@end
