//
//  Book.h
//  DBReader
//
//  Created by Ibokan on 13-4-16.
//  Copyright (c) 2013年 刘浩. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ReaderPinLun.h"
#import "ReadBook.h"
@interface Book : NSObject

@property(nonatomic,retain)NSString *title;
@property(nonatomic,retain)NSString *authorName;
@property(nonatomic,retain)NSString *bookId;
@property(nonatomic,retain)NSString *imageStr;
@property(nonatomic,retain)NSString *price;
@property(nonatomic,retain)NSString *author_intro;
@property(nonatomic,retain)UIImage *image;
@property(nonatomic,retain)NSString *pages;
@property(nonatomic,retain)NSString *summary;
@property(nonatomic,retain)NSString *translator;
@property(nonatomic,retain)NSString *tags;
@property(nonatomic,assign)NSInteger  pinglunCout;
@property(nonatomic,retain)NSString *publisher;
@property(nonatomic,retain)ReaderPinLun *bookPinLun;
@property(nonatomic,assign)BOOL hasReload;
//将ReadBook转换成book
+(Book *)bookWithReadBook:(ReadBook *)readbook ;
//创建一个 ReadBook 然后赋值
-(ReadBook *)createReadBookWithBook:(Book *)book;
@end
