//
//  RewiewCell.m
//  UIcellText
//
//  Created by ibokan on 13-4-18.
//  Copyright (c) 2013年 mengzilu. All rights reserved.
//

#import "RewiewCell.h"

@implementation RewiewCell

- (id)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier
{
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    if (self) {
        
        //设置评论表格的属性
        _rewiewerImage = [[UIImageView alloc] initWithFrame:CGRectMake(45.0, 10.0, 50.0, 50.0)];
        _rewiewerNameLabel = [[UILabel alloc] initWithFrame:CGRectMake(120.0, 10.0, 180.0, 30.0)];
        _rewiewContentLabel = [[UILabel alloc] initWithFrame:CGRectMake(18.0, 65.0, 275.0, 100.0)];
        _rewiewContentLabel.backgroundColor=[UIColor clearColor];
        
        _dateLabel = [[UILabel alloc] initWithFrame:CGRectMake(15.0, 150, 231.0, 30.0)];
       
        _moreButton=[UIButton buttonWithType:UIButtonTypeCustom];
               [_moreButton addTarget:self action:@selector(getMore) forControlEvents:UIControlEventTouchUpInside];
        _rewiewerNameLabel.font=[UIFont fontWithName:@"Arial" size:14];
        _dateLabel.font=[UIFont fontWithName:@"Arial" size:12];
    
        
        //content行内容自适应
       
        
        
        
        //加到表格上
        
        
        [self addSubview:_rewiewerNameLabel];
        [self addSubview:_rewiewerImage];
        [self addSubview:_dateLabel];
        [self addSubview:_rewiewContentLabel];
        [self addSubview:_moreButton];
    }
    return self;
}
-(void)getMore
{
    UITableView *tableview=(UITableView *)[self superview];
    if ([self.moreButton.titleLabel.text isEqualToString:@"收起<<"]) {
        
        NSLog(@"糖稀买了个表");
         if ([self.contentViewController respondsToSelector:@selector(packUpCellAtIndexPath:)])
         {
             [self.contentViewController packUpCellAtIndexPath:[tableview indexPathForCell:self]];
             
            [_moreButton setTitle:@"详细>>" forState:UIControlStateNormal];  
             
         }
    }
    else{
        
        if ([self.contentViewController respondsToSelector:@selector(reloadCellAtIndexPath:WithUrl:)])
        {
            
            [_moreButton setTitle:@"收起<<" forState:UIControlStateNormal];
            
                       [self.contentViewController reloadCellAtIndexPath:[tableview indexPathForCell:self] WithUrl:self.rewiew.summarylink];
        }

        
    }
    
    
}
//属性rewiew的set方法
-(void)setRewiew:(ReaderPinLun *)rewiew
{
    if ([_rewiew isEqual:rewiew]) {
        
        [_rewiew release],_rewiew=nil;
    }
    _rewiew=[rewiew retain];
    
    self.rewiewerNameLabel.text =rewiew.author;
    self.rewiewContentLabel.text =rewiew.summary;
    
    _dateLabel.frame=CGRectMake(15.0, 160, 231.0, 30.0);
    _moreButton.frame=CGRectMake(220.0, 140, 90, 55);

    self.dateLabel.text = rewiew.publishedTime;
        
       
    
    if (_rewiew.authorImage&&_rewiew.authorImage!=[UIImage imageNamed:@"11.jpg"]) {
        self.rewiewerImage.image = rewiew.authorImage;
    }
    [self.rewiewerImage setImageWithURL:[NSURL URLWithString:rewiew.authorImageStr] placeholderImage:[UIImage imageNamed:@"user_placeholder.jpg"] completed:^(UIImage *image, NSError *error, SDImageCacheType cacheType) {
        _rewiew.authorImage=image;
        NSLog(@"n第三方说的发生地方说的发生地方说的发生地方");
    }];
   
}



-(void)dealloc
{

//    
    [_rewiewContentLabel release];
    [_rewiewerImage release];
    [_rewiewerNameLabel release];
    [_dateLabel release];
    [_rewiew release];
    
    [super dealloc];
}

- (void)setSelected:(BOOL)selected animated:(BOOL)animated
{
    [super setSelected:selected animated:animated];
    
}

@end
